#include<stdio.h>
#include<pthread.h>
#include<unistd.h>
#include<stdlib.h>

#define turnP 0
#define turnQ 1
_Atomic volatile int needp;
_Atomic volatile int needq;
_Atomic volatile int turn;
void *P (void *v) {
	while (1) {
		needp=1;
		while (needq) {
			needp=0;
			while (turn == turnQ)
				;
			needp=1;
		}
		// critical code
		needp=0;
		turn=turnQ;
		// non critical code
	}
}

void *Q (void *v) {
	while (1) {
		needq=1;
		while (needp)
			needq=0;
			while (turn == turnP)
				;
			needq=1;
		}
		// critical code
		needq=0;
		turn=turnP;
		// non critical code
	}
}

int main(int argc, char *argv[]) {
	srandom(time(NULL));
	pthread_t pp;
	pthread_t qq;
	pthread_create(&pp, NULL, P, NULL);
	pthread_create(&qq, NULL, Q, NULL);
	pthread_join(pp, NULL);
	pthread_join(qq, NULL);
}
