#include<stdio.h>
#include<pthread.h>
#include<unistd.h>
#include<stdlib.h>

#define MAX 100
#define turnP 0
#define turnQ 1

_Atomic volatile int turn = 0;
void *P (void *v) {
	while(1) {
		while (turn == turnQ)
			;
		// critical code
		turn = turnQ;
		// non critical code
	}
}

void *Q (void *v) {
	while(1) {
		while (turn == turnP)
			;
		// critical code
		turn = turnP;
		// non critical code
	}
}

int main(int argc, char *argv[]) {
	srandom(time(NULL));
	pthread_t pp;
	pthread_t qq;
	pthread_create(&pp, NULL, P, NULL);
	pthread_create(&qq, NULL, Q, NULL);
	pthread_join(pp, NULL);
	pthread_join(qq, NULL);
}
