#include<stdio.h>
#include<pthread.h>
#include<unistd.h>
#include<stdlib.h>

#define MAX 10

#define P 0
#define Q 1

_Atomic volatile int needp;
_Atomic volatile int needq;
_Atomic volatile int turn;

void *p(void *arg) {
  int i;
  for (i = 0; i < MAX; i++) {
    needp=1;
    turn=Q;
    while(needq && turn != P)
			;
		// critical code
    needp=0;
		// non critical code
  }
}

void *q(void *arg) {
  int i;
  for (i = 0; i < MAX; i++) {
    needq=1;
    turn=P;
    while(needp && turn != Q)
			;
		// critical code
    needq=0;
		// non critical code
  }
}

int main(int argc, char *argv[]) {
  srandom(time(NULL));
  pthread_t pp;
  pthread_t pq;
  pthread_create(&pp, NULL, p, NULL);
  pthread_create(&pq, NULL, q, NULL);
  pthread_join(pp, NULL);
  pthread_join(pq, NULL);
}
